"""
Product initialization

$Id: __init__.py 23871 2006-05-24 10:34:33Z dbaty $
"""

from Products.CMFCore.utils import ToolInit, ContentInit
from Products.CMFCore.permissions import ManagePortal
from Products.CMFCore.DirectoryView import registerDirectory

from Products.Archetypes.public import listTypes, process_types

import patches
from config import GLOBALS, PROJECT_NAME, SKINS_DIR

registerDirectory(SKINS_DIR, GLOBALS)


def initialize(context):
    from content import *

    ## Initialize content types
    content_types, constructors, ftis = process_types(
        listTypes(PROJECT_NAME),
        PROJECT_NAME)

    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECT_NAME, atype.archetype_name)
        permission = ManagePortal
        ContentInit(kind,
                    content_types=(atype, ),
                    permission=permission,
                    extra_constructors=(constructor, ),
                    fti=ftis).initialize(context)
