# -*- coding: utf-8 -*-
# File  : config.py
#
# Copyright (c) 2005, Pilot Systems (http://www.pilotsystems.net)
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
"""Configuration

$Id: config.py 23871 2006-05-24 10:34:33Z dbaty $
"""

from Products.CMFCore.permissions import ManagePortal

PROJECT_NAME = 'StagingAddOn'
GLOBALS = globals()
SKINS_DIR = 'skins'

TESTING = False ## Set as True in unit tests

SKIN_DIRECTORIES = ('staging_add_on', )

CONFIGLETS = (
    {'id': 'staging_add_on_install',
     'name': 'staging_tool_title',
     'action': 'string:${portal_url}/portal_staging',
     'category': 'Products',
     'permission': ManagePortal,
     'imageUrl': 'product_icon.gif'
     },
    )

PORTLETS = ('here/portlet_staging/macros/portlet', )

PUBLISH_TRANSITION_POST_SCRIPT_ID = 'promoteVersion'

WORKFLOW_SCRIPTS = (
    {'id': 'createNewVersion',
     'params': 'state_change_info',
     'body': """\
from Products.CMFCore.utils import getToolByName

obj = state_change_info.object
staging_tool = getToolByName(obj, 'portal_staging')
staging_tool.createNewVersion(obj)"""},

    {'id': PUBLISH_TRANSITION_POST_SCRIPT_ID,
     'params': 'state_change_info',
     'body': """\
from Products.CMFCore.utils import getToolByName

obj = state_change_info.object
comment = state_change_info.kwargs.get('comment', '')
staging_tool = getToolByName(obj, 'portal_staging')
if staging_tool.isTheNewVersion(obj):
    staging_tool.promoteVersion(obj, comment)"""},
    )

expr = 'python: here.portal_staging.isAllowedToCreateNewVersion(here)'
NEW_TRANSITION_ID = 'createNewVersion'
NEW_TRANSITION_PROPERTIES = {'title': 'Create new version',
                             'description':'Create new version',
                             'new_state_id': '',
                             'trigger_type': 1,
                             'script_name': 'createNewVersion',
                             'actbox_name': 'Create new version',
                             'actbox_url': 'createNewVersion',
                             'actbox_category': 'workflow',
                             'props': {'guard_expr': expr}}
